<?php
include_once '../config/header.php';
include_once '../config/helper.php';
include_once '../config/database.php';
include_once '../objects/addons.php';
include_once '../token/validatetoken.php';

$database = new Database();
$db = $database->getConnection();

$addons = new Addons($db);

$searchKey = isset($_GET['key']) ? $_GET['key'] : die();
$addons->pageNo = isset($_GET['pageno']) ? $_GET['pageno'] : 1;
$addons->no_of_records_per_page = isset($_GET['pagesize']) ? $_GET['pagesize'] : 30;

$stmt = $addons->search($searchKey);
$num = $stmt->rowCount();
 
if($num>0){
    $addons_arr=array();
	$addons_arr["pageno"]=$addons->pageNo;
	$addons_arr["pagesize"]=$addons->no_of_records_per_page;
    $addons_arr["total_count"]=$addons->search_count($searchKey);
    $addons_arr["records"]=array();
    
    while ($row = $stmt->fetch(PDO::FETCH_ASSOC)){
        extract($row);
        $addons_item=array(
            
"addon_id" => $addon_id,
"service_id" => $service_id,
"type" => $type,
"price" => $price,
"status" => $status
        );
        array_push($addons_arr["records"], $addons_item);
    }
    http_response_code(200);
	echo json_encode(array("status" => "success", "code" => 1,"message"=> "addons found","document"=> $addons_arr));
}else{
    http_response_code(404);
	echo json_encode(array("status" => "error", "code" => 0,"message"=> "No addons found.","document"=> ""));
}
 


