<?php
include_once '../config/header.php';
include_once '../config/helper.php';
include_once '../config/database.php';
include_once '../objects/animals.php';
include_once '../token/validatetoken.php';

$database = new Database();
$db = $database->getConnection();

$animals = new Animals($db);

$searchKey = isset($_GET['key']) ? $_GET['key'] : die();
$animals->pageNo = isset($_GET['pageno']) ? $_GET['pageno'] : 1;
$animals->no_of_records_per_page = isset($_GET['pagesize']) ? $_GET['pagesize'] : 30;

$stmt = $animals->search($searchKey);
$num = $stmt->rowCount();
 
if($num>0){
    $animals_arr=array();
	$animals_arr["pageno"]=$animals->pageNo;
	$animals_arr["pagesize"]=$animals->no_of_records_per_page;
    $animals_arr["total_count"]=$animals->search_count($searchKey);
    $animals_arr["records"]=array();
    
    while ($row = $stmt->fetch(PDO::FETCH_ASSOC)){
        extract($row);
        $animals_item=array(
            
"animal_id" => $animal_id,
"animal_type" => $animal_type
        );
        array_push($animals_arr["records"], $animals_item);
    }
    http_response_code(200);
	echo json_encode(array("status" => "success", "code" => 1,"message"=> "animals found","document"=> $animals_arr));
}else{
    http_response_code(404);
	echo json_encode(array("status" => "error", "code" => 0,"message"=> "No animals found.","document"=> ""));
}
 


