<?php
include_once '../config/header.php';
include_once '../config/helper.php';
include_once '../config/database.php';
include_once '../objects/breeds.php';
include_once '../token/validatetoken.php';

$database = new Database();
$db = $database->getConnection();

$breeds = new Breeds($db);

$breeds->pageNo = isset($_GET['pageno']) ? $_GET['pageno'] : 1;
$breeds->no_of_records_per_page = isset($_GET['pagesize']) ? $_GET['pagesize'] : 30;
$breeds->animal_id = isset($_GET['animal_id']) ? $_GET['animal_id'] : die();

$stmt = $breeds->readByanimal_id();
$num = $stmt->rowCount();

if($num>0){
    $breeds_arr=array();
	$breeds_arr["pageno"]=$breeds->pageNo;
	$breeds_arr["pagesize"]=$breeds->no_of_records_per_page;
    $breeds_arr["total_count"]=$breeds->total_record_count();
    $breeds_arr["records"]=array();
    
    while ($row = $stmt->fetch(PDO::FETCH_ASSOC)){
        extract($row);
 
        $breeds_item=array(
            
"breed_id" => $breed_id,
"breed_type" => $breed_type,
"animal_type" => $animal_type,
"animal_id" => $animal_id
        );
        array_push($breeds_arr["records"], $breeds_item);
    }
    http_response_code(200);
	echo json_encode(array("status" => "success", "code" => 1,"message"=> "breeds found","document"=> $breeds_arr));
    
}else{
    http_response_code(404);
	echo json_encode(array("status" => "error", "code" => 0,"message"=> "No breeds found.","document"=> ""));
}
 


