<?php
include_once '../config/header.php';
include_once '../config/helper.php';
include_once '../config/database.php';
include_once '../objects/category.php';
include_once '../token/validatetoken.php';

$database = new Database();
$db = $database->getConnection();

$category = new Category($db);

$searchKey = isset($_GET['key']) ? $_GET['key'] : die();
$category->pageNo = isset($_GET['pageno']) ? $_GET['pageno'] : 1;
$category->no_of_records_per_page = isset($_GET['pagesize']) ? $_GET['pagesize'] : 30;

$stmt = $category->search($searchKey);
$num = $stmt->rowCount();
 
if($num>0){
    $category_arr=array();
	$category_arr["pageno"]=$category->pageNo;
	$category_arr["pagesize"]=$category->no_of_records_per_page;
    $category_arr["total_count"]=$category->search_count($searchKey);
    $category_arr["records"]=array();
    
    while ($row = $stmt->fetch(PDO::FETCH_ASSOC)){
        extract($row);
        $category_item=array(
            
"category_id" => $category_id,
"icon" => $icon,
"category_name" => $category_name,
"category_type" => $category_type
        );
        array_push($category_arr["records"], $category_item);
    }
    http_response_code(200);
	echo json_encode(array("status" => "success", "code" => 1,"message"=> "category found","document"=> $category_arr));
}else{
    http_response_code(404);
	echo json_encode(array("status" => "error", "code" => 0,"message"=> "No category found.","document"=> ""));
}
 


