<?php
class Address{
 
    private $conn;
    private $table_name = "address";
	public $pageNo = 1;
	public  $no_of_records_per_page=30;
	
public $address_id;
public $user_id;
public $address_name;
public $area;
public $block;
public $road;
public $bldg;
public $extra_details;
public $is_Selected;
public $status;
public $longitude;
public $latitude;
    
    public function __construct($db){
        $this->conn = $db;
    }

	function total_record_count() {
		$query = "select count(1) as total from ". $this->table_name ."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}

	function search_count($searchKey) {
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  WHERE LOWER(t.user_id) LIKE ? OR LOWER(t.address_name) LIKE ?  OR LOWER(t.area) LIKE ?  OR LOWER(t.block) LIKE ?  OR LOWER(t.road) LIKE ?  OR LOWER(t.bldg) LIKE ?  OR LOWER(t.extra_details) LIKE ?  OR LOWER(t.is_Selected) LIKE ?  OR LOWER(t.status) LIKE ?  OR LOWER(t.longitude) LIKE ?  OR LOWER(t.latitude) LIKE ? ";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
$stmt->bindParam(6, $searchKey);
$stmt->bindParam(7, $searchKey);
$stmt->bindParam(8, $searchKey);
$stmt->bindParam(9, $searchKey);
$stmt->bindParam(10, $searchKey);
$stmt->bindParam(11, $searchKey);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}
	
	function search_record_count($columnArray,$orAnd){
		$where="";
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  WHERE ".$where."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
		if(strtoupper($col->columnLogic)=="LIKE"){
		$columnValue="%".strtolower($col->columnValue)."%";
		}else{
		$columnValue=strtolower($col->columnValue);
		}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		 $num = $stmt->rowCount();
		if($num>0){
			return $row['total'];
		}else{
			return 0;
		}
	}
	function read(){
		if(isset($_GET["pageNo"])){
			$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  t.* FROM ". $this->table_name ." t  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		return $stmt;
	}
	function search($searchKey){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  t.* FROM ". $this->table_name ." t  WHERE LOWER(t.user_id) LIKE ? OR LOWER(t.address_name) LIKE ?  OR LOWER(t.area) LIKE ?  OR LOWER(t.block) LIKE ?  OR LOWER(t.road) LIKE ?  OR LOWER(t.bldg) LIKE ?  OR LOWER(t.extra_details) LIKE ?  OR LOWER(t.is_Selected) LIKE ?  OR LOWER(t.status) LIKE ?  OR LOWER(t.longitude) LIKE ?  OR LOWER(t.latitude) LIKE ?  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
$stmt->bindParam(6, $searchKey);
$stmt->bindParam(7, $searchKey);
$stmt->bindParam(8, $searchKey);
$stmt->bindParam(9, $searchKey);
$stmt->bindParam(10, $searchKey);
$stmt->bindParam(11, $searchKey);
		$stmt->execute();
		return $stmt;
	}
	function searchByColumn($columnArray,$orAnd){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$where="";
		
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT  t.* FROM ". $this->table_name ." t  WHERE ".$where." LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			if(strtoupper($col->columnLogic)=="LIKE"){
			$columnValue="%".strtolower($col->columnValue)."%";
			}else{
			$columnValue=strtolower($col->columnValue);
			}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		return $stmt;
	}
	
	

	function readOne(){
		$query = "SELECT  t.* FROM ". $this->table_name ." t  WHERE t.address_id = ? LIMIT 0,1";
		$stmt = $this->conn->prepare($query);
		$stmt->bindParam(1, $this->address_id);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		$num = $stmt->rowCount();
		if($num>0){
			
$this->address_id = $row['address_id'];
$this->user_id = $row['user_id'];
$this->address_name = $row['address_name'];
$this->area = $row['area'];
$this->block = $row['block'];
$this->road = $row['road'];
$this->bldg = $row['bldg'];
$this->extra_details = $row['extra_details'];
$this->is_Selected = $row['is_Selected'];
$this->status = $row['status'];
$this->longitude = $row['longitude'];
$this->latitude = $row['latitude'];
		}
		else{
			$this->address_id=null;
		}
	}
	function create(){
		$query ="INSERT INTO ".$this->table_name." SET user_id=:user_id,address_name=:address_name,area=:area,block=:block,road=:road,bldg=:bldg,extra_details=:extra_details,is_Selected=:is_Selected,status=:status,longitude=:longitude,latitude=:latitude";
		$stmt = $this->conn->prepare($query);
		
$this->user_id=htmlspecialchars(strip_tags($this->user_id));
$this->address_name=htmlspecialchars(strip_tags($this->address_name));
$this->area=htmlspecialchars(strip_tags($this->area));
$this->block=htmlspecialchars(strip_tags($this->block));
$this->road=htmlspecialchars(strip_tags($this->road));
$this->bldg=htmlspecialchars(strip_tags($this->bldg));
$this->extra_details=htmlspecialchars(strip_tags($this->extra_details));
$this->is_Selected=htmlspecialchars(strip_tags($this->is_Selected));
$this->status=htmlspecialchars(strip_tags($this->status));
$this->longitude=htmlspecialchars(strip_tags($this->longitude));
$this->latitude=htmlspecialchars(strip_tags($this->latitude));
		
$stmt->bindParam(":user_id", $this->user_id);
$stmt->bindParam(":address_name", $this->address_name);
$stmt->bindParam(":area", $this->area);
$stmt->bindParam(":block", $this->block);
$stmt->bindParam(":road", $this->road);
$stmt->bindParam(":bldg", $this->bldg);
$stmt->bindParam(":extra_details", $this->extra_details);
$stmt->bindParam(":is_Selected", $this->is_Selected);
$stmt->bindParam(":status", $this->status);
$stmt->bindParam(":longitude", $this->longitude);
$stmt->bindParam(":latitude", $this->latitude);
		if($stmt->execute()){
			return  $this->conn->lastInsertId();
		}
		return 0;
	}
	function update(){
		$query ="UPDATE ".$this->table_name." SET user_id=:user_id,address_name=:address_name,area=:area,block=:block,road=:road,bldg=:bldg,extra_details=:extra_details,is_Selected=:is_Selected,status=:status,longitude=:longitude,latitude=:latitude WHERE address_id = :address_id";
		$stmt = $this->conn->prepare($query);
		
$this->user_id=htmlspecialchars(strip_tags($this->user_id));
$this->address_name=htmlspecialchars(strip_tags($this->address_name));
$this->area=htmlspecialchars(strip_tags($this->area));
$this->block=htmlspecialchars(strip_tags($this->block));
$this->road=htmlspecialchars(strip_tags($this->road));
$this->bldg=htmlspecialchars(strip_tags($this->bldg));
$this->extra_details=htmlspecialchars(strip_tags($this->extra_details));
$this->is_Selected=htmlspecialchars(strip_tags($this->is_Selected));
$this->status=htmlspecialchars(strip_tags($this->status));
$this->longitude=htmlspecialchars(strip_tags($this->longitude));
$this->latitude=htmlspecialchars(strip_tags($this->latitude));
$this->address_id=htmlspecialchars(strip_tags($this->address_id));
		
$stmt->bindParam(":user_id", $this->user_id);
$stmt->bindParam(":address_name", $this->address_name);
$stmt->bindParam(":area", $this->area);
$stmt->bindParam(":block", $this->block);
$stmt->bindParam(":road", $this->road);
$stmt->bindParam(":bldg", $this->bldg);
$stmt->bindParam(":extra_details", $this->extra_details);
$stmt->bindParam(":is_Selected", $this->is_Selected);
$stmt->bindParam(":status", $this->status);
$stmt->bindParam(":longitude", $this->longitude);
$stmt->bindParam(":latitude", $this->latitude);
$stmt->bindParam(":address_id", $this->address_id);
		$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
	}
	function update_patch($jsonObj) {
			$query ="UPDATE ".$this->table_name. " SET ";
			$setValue="";
			$colCount=1;
			foreach($jsonObj as $key => $value) 
			{
				$columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='address_id'){
				if($colCount===1){
					$setValue = $columnName."=:".$columnName;
				}else{
					$setValue = $setValue . "," .$columnName."=:".$columnName;
				}
				$colCount++;
				}
			}
			$setValue = rtrim($setValue,',');
			$query = $query . " " . $setValue . " WHERE address_id = :address_id"; 
			$stmt = $this->conn->prepare($query);
			foreach($jsonObj as $key => $value) 
			{
			    $columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='address_id'){
				$colValue=htmlspecialchars(strip_tags($value));
				$stmt->bindValue(":".$columnName, $colValue);
				}
			}
			$stmt->bindParam(":address_id", $this->address_id);
			$stmt->execute();

			if($stmt->rowCount()) {
				return true;
			} else {
				return false;
			}
	}
	function delete(){
		$query = "DELETE FROM " . $this->table_name . " WHERE address_id = ? ";
		$stmt = $this->conn->prepare($query);
		$this->address_id=htmlspecialchars(strip_tags($this->address_id));

		$stmt->bindParam(1, $this->address_id);

	 	$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
		 
	}

	
}
?>
