<?php
class Appointment{
 
    private $conn;
    private $table_name = "appointment";
	public $pageNo = 1;
	public  $no_of_records_per_page=30;
	
public $appointment_id;
public $user_id;
public $pet_id;
public $date;
public $start_time;
public $end_time;
public $service_id;
public $added_date;
public $payment_type;
public $status;
public $date_deleted;
public $first_name;
    
    public function __construct($db){
        $this->conn = $db;
    }

	function total_record_count() {
		$query = "select count(1) as total from ". $this->table_name ."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}

	function search_count($searchKey) {
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  join users ddd on t.user_id = ddd.user_id  WHERE LOWER(t.user_id) LIKE ? OR LOWER(t.pet_id) LIKE ?  OR LOWER(t.date) LIKE ?  OR LOWER(t.start_time) LIKE ?  OR LOWER(t.end_time) LIKE ?  OR LOWER(t.service_id) LIKE ?  OR LOWER(t.added_date) LIKE ?  OR LOWER(t.payment_type) LIKE ?  OR LOWER(t.status) LIKE ?  OR LOWER(t.date_deleted) LIKE ? ";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
$stmt->bindParam(6, $searchKey);
$stmt->bindParam(7, $searchKey);
$stmt->bindParam(8, $searchKey);
$stmt->bindParam(9, $searchKey);
$stmt->bindParam(10, $searchKey);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}
	
	function search_record_count($columnArray,$orAnd){
		$where="";
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  join users ddd on t.user_id = ddd.user_id  WHERE ".$where."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
		if(strtoupper($col->columnLogic)=="LIKE"){
		$columnValue="%".strtolower($col->columnValue)."%";
		}else{
		$columnValue=strtolower($col->columnValue);
		}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		 $num = $stmt->rowCount();
		if($num>0){
			return $row['total'];
		}else{
			return 0;
		}
	}
	function read(){
		if(isset($_GET["pageNo"])){
			$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  ddd.first_name, t.* FROM ". $this->table_name ." t  join users ddd on t.user_id = ddd.user_id  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		return $stmt;
	}
	function search($searchKey){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  ddd.first_name, t.* FROM ". $this->table_name ." t  join users ddd on t.user_id = ddd.user_id  WHERE LOWER(t.user_id) LIKE ? OR LOWER(t.pet_id) LIKE ?  OR LOWER(t.date) LIKE ?  OR LOWER(t.start_time) LIKE ?  OR LOWER(t.end_time) LIKE ?  OR LOWER(t.service_id) LIKE ?  OR LOWER(t.added_date) LIKE ?  OR LOWER(t.payment_type) LIKE ?  OR LOWER(t.status) LIKE ?  OR LOWER(t.date_deleted) LIKE ?  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
$stmt->bindParam(6, $searchKey);
$stmt->bindParam(7, $searchKey);
$stmt->bindParam(8, $searchKey);
$stmt->bindParam(9, $searchKey);
$stmt->bindParam(10, $searchKey);
		$stmt->execute();
		return $stmt;
	}
	function searchByColumn($columnArray,$orAnd){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$where="";
		
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT  ddd.first_name, t.* FROM ". $this->table_name ." t  join users ddd on t.user_id = ddd.user_id  WHERE ".$where." LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			if(strtoupper($col->columnLogic)=="LIKE"){
			$columnValue="%".strtolower($col->columnValue)."%";
			}else{
			$columnValue=strtolower($col->columnValue);
			}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		return $stmt;
	}
	
	

	function readOne(){
		$query = "SELECT  ddd.first_name, t.* FROM ". $this->table_name ." t  join users ddd on t.user_id = ddd.user_id  WHERE t.appointment_id = ? LIMIT 0,1";
		$stmt = $this->conn->prepare($query);
		$stmt->bindParam(1, $this->appointment_id);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		$num = $stmt->rowCount();
		if($num>0){
			
$this->appointment_id = $row['appointment_id'];
$this->user_id = $row['user_id'];
$this->first_name = $row['first_name'];
$this->pet_id = $row['pet_id'];
$this->date = $row['date'];
$this->start_time = $row['start_time'];
$this->end_time = $row['end_time'];
$this->service_id = $row['service_id'];
$this->added_date = $row['added_date'];
$this->payment_type = $row['payment_type'];
$this->status = $row['status'];
$this->date_deleted = $row['date_deleted'];
		}
		else{
			$this->appointment_id=null;
		}
	}
	function create(){
		$query ="INSERT INTO ".$this->table_name." SET user_id=:user_id,pet_id=:pet_id,date=:date,start_time=:start_time,end_time=:end_time,service_id=:service_id,added_date=:added_date,payment_type=:payment_type,status=:status,date_deleted=:date_deleted";
		$stmt = $this->conn->prepare($query);
		
$this->user_id=htmlspecialchars(strip_tags($this->user_id));
$this->pet_id=htmlspecialchars(strip_tags($this->pet_id));
$this->date=htmlspecialchars(strip_tags($this->date));
$this->start_time=htmlspecialchars(strip_tags($this->start_time));
$this->end_time=htmlspecialchars(strip_tags($this->end_time));
$this->service_id=htmlspecialchars(strip_tags($this->service_id));
$this->added_date=htmlspecialchars(strip_tags($this->added_date));
$this->payment_type=htmlspecialchars(strip_tags($this->payment_type));
$this->status=htmlspecialchars(strip_tags($this->status));
$this->date_deleted=htmlspecialchars(strip_tags($this->date_deleted));
		
$stmt->bindParam(":user_id", $this->user_id);
$stmt->bindParam(":pet_id", $this->pet_id);
$stmt->bindParam(":date", $this->date);
$stmt->bindParam(":start_time", $this->start_time);
$stmt->bindParam(":end_time", $this->end_time);
$stmt->bindParam(":service_id", $this->service_id);
$stmt->bindParam(":added_date", $this->added_date);
$stmt->bindParam(":payment_type", $this->payment_type);
$stmt->bindParam(":status", $this->status);
$stmt->bindParam(":date_deleted", $this->date_deleted);
		if($stmt->execute()){
			return  $this->conn->lastInsertId();
		}
		return 0;
	}
	function update(){
		$query ="UPDATE ".$this->table_name." SET user_id=:user_id,pet_id=:pet_id,date=:date,start_time=:start_time,end_time=:end_time,service_id=:service_id,added_date=:added_date,payment_type=:payment_type,status=:status,date_deleted=:date_deleted WHERE appointment_id = :appointment_id";
		$stmt = $this->conn->prepare($query);
		
$this->user_id=htmlspecialchars(strip_tags($this->user_id));
$this->pet_id=htmlspecialchars(strip_tags($this->pet_id));
$this->date=htmlspecialchars(strip_tags($this->date));
$this->start_time=htmlspecialchars(strip_tags($this->start_time));
$this->end_time=htmlspecialchars(strip_tags($this->end_time));
$this->service_id=htmlspecialchars(strip_tags($this->service_id));
$this->added_date=htmlspecialchars(strip_tags($this->added_date));
$this->payment_type=htmlspecialchars(strip_tags($this->payment_type));
$this->status=htmlspecialchars(strip_tags($this->status));
$this->date_deleted=htmlspecialchars(strip_tags($this->date_deleted));
$this->appointment_id=htmlspecialchars(strip_tags($this->appointment_id));
		
$stmt->bindParam(":user_id", $this->user_id);
$stmt->bindParam(":pet_id", $this->pet_id);
$stmt->bindParam(":date", $this->date);
$stmt->bindParam(":start_time", $this->start_time);
$stmt->bindParam(":end_time", $this->end_time);
$stmt->bindParam(":service_id", $this->service_id);
$stmt->bindParam(":added_date", $this->added_date);
$stmt->bindParam(":payment_type", $this->payment_type);
$stmt->bindParam(":status", $this->status);
$stmt->bindParam(":date_deleted", $this->date_deleted);
$stmt->bindParam(":appointment_id", $this->appointment_id);
		$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
	}
	function update_patch($jsonObj) {
			$query ="UPDATE ".$this->table_name. " SET ";
			$setValue="";
			$colCount=1;
			foreach($jsonObj as $key => $value) 
			{
				$columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='appointment_id'){
				if($colCount===1){
					$setValue = $columnName."=:".$columnName;
				}else{
					$setValue = $setValue . "," .$columnName."=:".$columnName;
				}
				$colCount++;
				}
			}
			$setValue = rtrim($setValue,',');
			$query = $query . " " . $setValue . " WHERE appointment_id = :appointment_id"; 
			$stmt = $this->conn->prepare($query);
			foreach($jsonObj as $key => $value) 
			{
			    $columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='appointment_id'){
				$colValue=htmlspecialchars(strip_tags($value));
				$stmt->bindValue(":".$columnName, $colValue);
				}
			}
			$stmt->bindParam(":appointment_id", $this->appointment_id);
			$stmt->execute();

			if($stmt->rowCount()) {
				return true;
			} else {
				return false;
			}
	}
	function delete(){
		$query = "DELETE FROM " . $this->table_name . " WHERE appointment_id = ? ";
		$stmt = $this->conn->prepare($query);
		$this->appointment_id=htmlspecialchars(strip_tags($this->appointment_id));

		$stmt->bindParam(1, $this->appointment_id);

	 	$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
		 
	}

	
function readByuser_id(){

if (isset($_GET["pageNo"]))
{
$this->pageNo =$_GET["pageNo"]; } 
$offset = ($this->pageNo - 1) * $this->no_of_records_per_page;
$query = "SELECT  ddd.first_name, t.* FROM ". $this->table_name ." t  join users ddd on t.user_id = ddd.user_id  WHERE t.user_id = ? LIMIT ".$offset." , ". $this->no_of_records_per_page."";

$stmt = $this->conn->prepare( $query );
$stmt->bindParam(1, $this->user_id);

$stmt->execute();
return $stmt;
}

}
?>
