<?php
class Banner{
 
    private $conn;
    private $table_name = "banner";
	public $pageNo = 1;
	public  $no_of_records_per_page=30;
	
public $banner_id;
public $service_id;
public $type;
public $banner_image;
public $added_date;
public $start_date;
public $end_date;
public $banner_status;
public $date_deleted;
public $service_name;
    
    public function __construct($db){
        $this->conn = $db;
    }

	function total_record_count() {
		$query = "select count(1) as total from ". $this->table_name ."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}

	function search_count($searchKey) {
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  join services bb on t.service_id = bb.service_id  WHERE LOWER(t.service_id) LIKE ? OR LOWER(t.type) LIKE ?  OR LOWER(t.banner_image) LIKE ?  OR LOWER(t.added_date) LIKE ?  OR LOWER(t.start_date) LIKE ?  OR LOWER(t.end_date) LIKE ?  OR LOWER(t.banner_status) LIKE ?  OR LOWER(t.date_deleted) LIKE ? ";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
$stmt->bindParam(6, $searchKey);
$stmt->bindParam(7, $searchKey);
$stmt->bindParam(8, $searchKey);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}
	
	function search_record_count($columnArray,$orAnd){
		$where="";
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  join services bb on t.service_id = bb.service_id  WHERE ".$where."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
		if(strtoupper($col->columnLogic)=="LIKE"){
		$columnValue="%".strtolower($col->columnValue)."%";
		}else{
		$columnValue=strtolower($col->columnValue);
		}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		 $num = $stmt->rowCount();
		if($num>0){
			return $row['total'];
		}else{
			return 0;
		}
	}
	function read(){
		if(isset($_GET["pageNo"])){
			$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  bb.service_name, t.* FROM ". $this->table_name ." t  join services bb on t.service_id = bb.service_id  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		return $stmt;
	}
	function search($searchKey){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  bb.service_name, t.* FROM ". $this->table_name ." t  join services bb on t.service_id = bb.service_id  WHERE LOWER(t.service_id) LIKE ? OR LOWER(t.type) LIKE ?  OR LOWER(t.banner_image) LIKE ?  OR LOWER(t.added_date) LIKE ?  OR LOWER(t.start_date) LIKE ?  OR LOWER(t.end_date) LIKE ?  OR LOWER(t.banner_status) LIKE ?  OR LOWER(t.date_deleted) LIKE ?  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
$stmt->bindParam(6, $searchKey);
$stmt->bindParam(7, $searchKey);
$stmt->bindParam(8, $searchKey);
		$stmt->execute();
		return $stmt;
	}
	function searchByColumn($columnArray,$orAnd){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$where="";
		
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT  bb.service_name, t.* FROM ". $this->table_name ." t  join services bb on t.service_id = bb.service_id  WHERE ".$where." LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			if(strtoupper($col->columnLogic)=="LIKE"){
			$columnValue="%".strtolower($col->columnValue)."%";
			}else{
			$columnValue=strtolower($col->columnValue);
			}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		return $stmt;
	}
	
	

	function readOne(){
		$query = "SELECT  bb.service_name, t.* FROM ". $this->table_name ." t  join services bb on t.service_id = bb.service_id  WHERE t.banner_id = ? LIMIT 0,1";
		$stmt = $this->conn->prepare($query);
		$stmt->bindParam(1, $this->banner_id);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		$num = $stmt->rowCount();
		if($num>0){
			
$this->banner_id = $row['banner_id'];
$this->service_id = $row['service_id'];
$this->service_name = $row['service_name'];
$this->type = $row['type'];
$this->banner_image = $row['banner_image'];
$this->added_date = $row['added_date'];
$this->start_date = $row['start_date'];
$this->end_date = $row['end_date'];
$this->banner_status = $row['banner_status'];
$this->date_deleted = $row['date_deleted'];
		}
		else{
			$this->banner_id=null;
		}
	}
	function create(){
		$query ="INSERT INTO ".$this->table_name." SET service_id=:service_id,type=:type,banner_image=:banner_image,added_date=:added_date,start_date=:start_date,end_date=:end_date,banner_status=:banner_status,date_deleted=:date_deleted";
		$stmt = $this->conn->prepare($query);
		
$this->service_id=htmlspecialchars(strip_tags($this->service_id));
$this->type=htmlspecialchars(strip_tags($this->type));
$this->banner_image=htmlspecialchars(strip_tags($this->banner_image));
$this->added_date=htmlspecialchars(strip_tags($this->added_date));
$this->start_date=htmlspecialchars(strip_tags($this->start_date));
$this->end_date=htmlspecialchars(strip_tags($this->end_date));
$this->banner_status=htmlspecialchars(strip_tags($this->banner_status));
$this->date_deleted=htmlspecialchars(strip_tags($this->date_deleted));
		
$stmt->bindParam(":service_id", $this->service_id);
$stmt->bindParam(":type", $this->type);
$stmt->bindParam(":banner_image", $this->banner_image);
$stmt->bindParam(":added_date", $this->added_date);
$stmt->bindParam(":start_date", $this->start_date);
$stmt->bindParam(":end_date", $this->end_date);
$stmt->bindParam(":banner_status", $this->banner_status);
$stmt->bindParam(":date_deleted", $this->date_deleted);
		if($stmt->execute()){
			return  $this->conn->lastInsertId();
		}
		return 0;
	}
	function update(){
		$query ="UPDATE ".$this->table_name." SET service_id=:service_id,type=:type,banner_image=:banner_image,added_date=:added_date,start_date=:start_date,end_date=:end_date,banner_status=:banner_status,date_deleted=:date_deleted WHERE banner_id = :banner_id";
		$stmt = $this->conn->prepare($query);
		
$this->service_id=htmlspecialchars(strip_tags($this->service_id));
$this->type=htmlspecialchars(strip_tags($this->type));
$this->banner_image=htmlspecialchars(strip_tags($this->banner_image));
$this->added_date=htmlspecialchars(strip_tags($this->added_date));
$this->start_date=htmlspecialchars(strip_tags($this->start_date));
$this->end_date=htmlspecialchars(strip_tags($this->end_date));
$this->banner_status=htmlspecialchars(strip_tags($this->banner_status));
$this->date_deleted=htmlspecialchars(strip_tags($this->date_deleted));
$this->banner_id=htmlspecialchars(strip_tags($this->banner_id));
		
$stmt->bindParam(":service_id", $this->service_id);
$stmt->bindParam(":type", $this->type);
$stmt->bindParam(":banner_image", $this->banner_image);
$stmt->bindParam(":added_date", $this->added_date);
$stmt->bindParam(":start_date", $this->start_date);
$stmt->bindParam(":end_date", $this->end_date);
$stmt->bindParam(":banner_status", $this->banner_status);
$stmt->bindParam(":date_deleted", $this->date_deleted);
$stmt->bindParam(":banner_id", $this->banner_id);
		$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
	}
	function update_patch($jsonObj) {
			$query ="UPDATE ".$this->table_name. " SET ";
			$setValue="";
			$colCount=1;
			foreach($jsonObj as $key => $value) 
			{
				$columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='banner_id'){
				if($colCount===1){
					$setValue = $columnName."=:".$columnName;
				}else{
					$setValue = $setValue . "," .$columnName."=:".$columnName;
				}
				$colCount++;
				}
			}
			$setValue = rtrim($setValue,',');
			$query = $query . " " . $setValue . " WHERE banner_id = :banner_id"; 
			$stmt = $this->conn->prepare($query);
			foreach($jsonObj as $key => $value) 
			{
			    $columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='banner_id'){
				$colValue=htmlspecialchars(strip_tags($value));
				$stmt->bindValue(":".$columnName, $colValue);
				}
			}
			$stmt->bindParam(":banner_id", $this->banner_id);
			$stmt->execute();

			if($stmt->rowCount()) {
				return true;
			} else {
				return false;
			}
	}
	function delete(){
		$query = "DELETE FROM " . $this->table_name . " WHERE banner_id = ? ";
		$stmt = $this->conn->prepare($query);
		$this->banner_id=htmlspecialchars(strip_tags($this->banner_id));

		$stmt->bindParam(1, $this->banner_id);

	 	$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
		 
	}

	
function readByservice_id(){

if (isset($_GET["pageNo"]))
{
$this->pageNo =$_GET["pageNo"]; } 
$offset = ($this->pageNo - 1) * $this->no_of_records_per_page;
$query = "SELECT  bb.service_name, t.* FROM ". $this->table_name ." t  join services bb on t.service_id = bb.service_id  WHERE t.service_id = ? LIMIT ".$offset." , ". $this->no_of_records_per_page."";

$stmt = $this->conn->prepare( $query );
$stmt->bindParam(1, $this->service_id);

$stmt->execute();
return $stmt;
}

}
?>
