<?php
class Notifications{
 
    private $conn;
    private $table_name = "notifications";
	public $pageNo = 1;
	public  $no_of_records_per_page=30;
	
public $notification_id;
public $user_id;
public $tokens;
public $notification_title;
public $notification_body;
public $created_at;
    
    public function __construct($db){
        $this->conn = $db;
    }

	function total_record_count() {
		$query = "select count(1) as total from ". $this->table_name ."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}

	function search_count($searchKey) {
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  WHERE LOWER(t.user_id) LIKE ? OR LOWER(t.tokens) LIKE ?  OR LOWER(t.notification_title) LIKE ?  OR LOWER(t.notification_body) LIKE ?  OR LOWER(t.created_at) LIKE ? ";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}
	
	function search_record_count($columnArray,$orAnd){
		$where="";
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  WHERE ".$where."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
		if(strtoupper($col->columnLogic)=="LIKE"){
		$columnValue="%".strtolower($col->columnValue)."%";
		}else{
		$columnValue=strtolower($col->columnValue);
		}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		 $num = $stmt->rowCount();
		if($num>0){
			return $row['total'];
		}else{
			return 0;
		}
	}
	function read(){
		if(isset($_GET["pageNo"])){
			$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  t.* FROM ". $this->table_name ." t  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		return $stmt;
	}
	function search($searchKey){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  t.* FROM ". $this->table_name ." t  WHERE LOWER(t.user_id) LIKE ? OR LOWER(t.tokens) LIKE ?  OR LOWER(t.notification_title) LIKE ?  OR LOWER(t.notification_body) LIKE ?  OR LOWER(t.created_at) LIKE ?  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
		$stmt->execute();
		return $stmt;
	}
	function searchByColumn($columnArray,$orAnd){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$where="";
		
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT  t.* FROM ". $this->table_name ." t  WHERE ".$where." LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			if(strtoupper($col->columnLogic)=="LIKE"){
			$columnValue="%".strtolower($col->columnValue)."%";
			}else{
			$columnValue=strtolower($col->columnValue);
			}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		return $stmt;
	}
	
	

	function readOne(){
		$query = "SELECT  t.* FROM ". $this->table_name ." t  WHERE t.notification_id = ? LIMIT 0,1";
		$stmt = $this->conn->prepare($query);
		$stmt->bindParam(1, $this->notification_id);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		$num = $stmt->rowCount();
		if($num>0){
			
$this->notification_id = $row['notification_id'];
$this->user_id = $row['user_id'];
$this->tokens = $row['tokens'];
$this->notification_title = $row['notification_title'];
$this->notification_body = $row['notification_body'];
$this->created_at = $row['created_at'];
		}
		else{
			$this->notification_id=null;
		}
	}
	function create(){
		$query ="INSERT INTO ".$this->table_name." SET user_id=:user_id,tokens=:tokens,notification_title=:notification_title,notification_body=:notification_body,created_at=:created_at";
		$stmt = $this->conn->prepare($query);
		
$this->user_id=htmlspecialchars(strip_tags($this->user_id));
$this->tokens=htmlspecialchars(strip_tags($this->tokens));
$this->notification_title=htmlspecialchars(strip_tags($this->notification_title));
$this->notification_body=htmlspecialchars(strip_tags($this->notification_body));
$this->created_at=htmlspecialchars(strip_tags($this->created_at));
		
$stmt->bindParam(":user_id", $this->user_id);
$stmt->bindParam(":tokens", $this->tokens);
$stmt->bindParam(":notification_title", $this->notification_title);
$stmt->bindParam(":notification_body", $this->notification_body);
$stmt->bindParam(":created_at", $this->created_at);
		if($stmt->execute()){
			return  $this->conn->lastInsertId();
		}
		return 0;
	}
	function update(){
		$query ="UPDATE ".$this->table_name." SET user_id=:user_id,tokens=:tokens,notification_title=:notification_title,notification_body=:notification_body,created_at=:created_at WHERE notification_id = :notification_id";
		$stmt = $this->conn->prepare($query);
		
$this->user_id=htmlspecialchars(strip_tags($this->user_id));
$this->tokens=htmlspecialchars(strip_tags($this->tokens));
$this->notification_title=htmlspecialchars(strip_tags($this->notification_title));
$this->notification_body=htmlspecialchars(strip_tags($this->notification_body));
$this->created_at=htmlspecialchars(strip_tags($this->created_at));
$this->notification_id=htmlspecialchars(strip_tags($this->notification_id));
		
$stmt->bindParam(":user_id", $this->user_id);
$stmt->bindParam(":tokens", $this->tokens);
$stmt->bindParam(":notification_title", $this->notification_title);
$stmt->bindParam(":notification_body", $this->notification_body);
$stmt->bindParam(":created_at", $this->created_at);
$stmt->bindParam(":notification_id", $this->notification_id);
		$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
	}
	function update_patch($jsonObj) {
			$query ="UPDATE ".$this->table_name. " SET ";
			$setValue="";
			$colCount=1;
			foreach($jsonObj as $key => $value) 
			{
				$columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='notification_id'){
				if($colCount===1){
					$setValue = $columnName."=:".$columnName;
				}else{
					$setValue = $setValue . "," .$columnName."=:".$columnName;
				}
				$colCount++;
				}
			}
			$setValue = rtrim($setValue,',');
			$query = $query . " " . $setValue . " WHERE notification_id = :notification_id"; 
			$stmt = $this->conn->prepare($query);
			foreach($jsonObj as $key => $value) 
			{
			    $columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='notification_id'){
				$colValue=htmlspecialchars(strip_tags($value));
				$stmt->bindValue(":".$columnName, $colValue);
				}
			}
			$stmt->bindParam(":notification_id", $this->notification_id);
			$stmt->execute();

			if($stmt->rowCount()) {
				return true;
			} else {
				return false;
			}
	}
	function delete(){
		$query = "DELETE FROM " . $this->table_name . " WHERE notification_id = ? ";
		$stmt = $this->conn->prepare($query);
		$this->notification_id=htmlspecialchars(strip_tags($this->notification_id));

		$stmt->bindParam(1, $this->notification_id);

	 	$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
		 
	}

	
}
?>
