<?php
class Orders{
 
    private $conn;
    private $table_name = "orders";
	public $pageNo = 1;
	public  $no_of_records_per_page=30;
	
public $order_id;
public $user_id;
public $order_type;
public $order_date;
public $shipping_date;
public $order_status;
public $total_price;
public $payment_type;
public $address_id;
    
    public function __construct($db){
        $this->conn = $db;
    }

	function total_record_count() {
		$query = "select count(1) as total from ". $this->table_name ."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}

	function search_count($searchKey) {
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  WHERE LOWER(t.user_id) LIKE ? OR LOWER(t.order_type) LIKE ?  OR LOWER(t.order_date) LIKE ?  OR LOWER(t.shipping_date) LIKE ?  OR LOWER(t.order_status) LIKE ?  OR LOWER(t.total_price) LIKE ?  OR LOWER(t.payment_type) LIKE ?  OR LOWER(t.address_id) LIKE ? ";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
$stmt->bindParam(6, $searchKey);
$stmt->bindParam(7, $searchKey);
$stmt->bindParam(8, $searchKey);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}
	
	function search_record_count($columnArray,$orAnd){
		$where="";
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  WHERE ".$where."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
		if(strtoupper($col->columnLogic)=="LIKE"){
		$columnValue="%".strtolower($col->columnValue)."%";
		}else{
		$columnValue=strtolower($col->columnValue);
		}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		 $num = $stmt->rowCount();
		if($num>0){
			return $row['total'];
		}else{
			return 0;
		}
	}
	function read(){
		if(isset($_GET["pageNo"])){
			$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  t.* FROM ". $this->table_name ." t  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		return $stmt;
	}
	function search($searchKey){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  t.* FROM ". $this->table_name ." t  WHERE LOWER(t.user_id) LIKE ? OR LOWER(t.order_type) LIKE ?  OR LOWER(t.order_date) LIKE ?  OR LOWER(t.shipping_date) LIKE ?  OR LOWER(t.order_status) LIKE ?  OR LOWER(t.total_price) LIKE ?  OR LOWER(t.payment_type) LIKE ?  OR LOWER(t.address_id) LIKE ?  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
$stmt->bindParam(6, $searchKey);
$stmt->bindParam(7, $searchKey);
$stmt->bindParam(8, $searchKey);
		$stmt->execute();
		return $stmt;
	}
	function searchByColumn($columnArray,$orAnd){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$where="";
		
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT  t.* FROM ". $this->table_name ." t  WHERE ".$where." LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			if(strtoupper($col->columnLogic)=="LIKE"){
			$columnValue="%".strtolower($col->columnValue)."%";
			}else{
			$columnValue=strtolower($col->columnValue);
			}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		return $stmt;
	}
	
	

	function readOne(){
		$query = "SELECT  t.* FROM ". $this->table_name ." t  WHERE t.order_id = ? LIMIT 0,1";
		$stmt = $this->conn->prepare($query);
		$stmt->bindParam(1, $this->order_id);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		$num = $stmt->rowCount();
		if($num>0){
			
$this->order_id = $row['order_id'];
$this->user_id = $row['user_id'];
$this->order_type = $row['order_type'];
$this->order_date = $row['order_date'];
$this->shipping_date = $row['shipping_date'];
$this->order_status = $row['order_status'];
$this->total_price = $row['total_price'];
$this->payment_type = $row['payment_type'];
$this->address_id = $row['address_id'];
		}
		else{
			$this->order_id=null;
		}
	}
	function create(){
		$query ="INSERT INTO ".$this->table_name." SET user_id=:user_id,order_type=:order_type,order_date=:order_date,shipping_date=:shipping_date,order_status=:order_status,total_price=:total_price,payment_type=:payment_type,address_id=:address_id";
		$stmt = $this->conn->prepare($query);
		
$this->user_id=htmlspecialchars(strip_tags($this->user_id));
$this->order_type=htmlspecialchars(strip_tags($this->order_type));
$this->order_date=htmlspecialchars(strip_tags($this->order_date));
$this->shipping_date=htmlspecialchars(strip_tags($this->shipping_date));
$this->order_status=htmlspecialchars(strip_tags($this->order_status));
$this->total_price=htmlspecialchars(strip_tags($this->total_price));
$this->payment_type=htmlspecialchars(strip_tags($this->payment_type));
$this->address_id=htmlspecialchars(strip_tags($this->address_id));
		
$stmt->bindParam(":user_id", $this->user_id);
$stmt->bindParam(":order_type", $this->order_type);
$stmt->bindParam(":order_date", $this->order_date);
$stmt->bindParam(":shipping_date", $this->shipping_date);
$stmt->bindParam(":order_status", $this->order_status);
$stmt->bindParam(":total_price", $this->total_price);
$stmt->bindParam(":payment_type", $this->payment_type);
$stmt->bindParam(":address_id", $this->address_id);
		if($stmt->execute()){
			return  $this->conn->lastInsertId();
		}
		return 0;
	}
	function update(){
		$query ="UPDATE ".$this->table_name." SET user_id=:user_id,order_type=:order_type,order_date=:order_date,shipping_date=:shipping_date,order_status=:order_status,total_price=:total_price,payment_type=:payment_type,address_id=:address_id WHERE order_id = :order_id";
		$stmt = $this->conn->prepare($query);
		
$this->user_id=htmlspecialchars(strip_tags($this->user_id));
$this->order_type=htmlspecialchars(strip_tags($this->order_type));
$this->order_date=htmlspecialchars(strip_tags($this->order_date));
$this->shipping_date=htmlspecialchars(strip_tags($this->shipping_date));
$this->order_status=htmlspecialchars(strip_tags($this->order_status));
$this->total_price=htmlspecialchars(strip_tags($this->total_price));
$this->payment_type=htmlspecialchars(strip_tags($this->payment_type));
$this->address_id=htmlspecialchars(strip_tags($this->address_id));
$this->order_id=htmlspecialchars(strip_tags($this->order_id));
		
$stmt->bindParam(":user_id", $this->user_id);
$stmt->bindParam(":order_type", $this->order_type);
$stmt->bindParam(":order_date", $this->order_date);
$stmt->bindParam(":shipping_date", $this->shipping_date);
$stmt->bindParam(":order_status", $this->order_status);
$stmt->bindParam(":total_price", $this->total_price);
$stmt->bindParam(":payment_type", $this->payment_type);
$stmt->bindParam(":address_id", $this->address_id);
$stmt->bindParam(":order_id", $this->order_id);
		$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
	}
	function update_patch($jsonObj) {
			$query ="UPDATE ".$this->table_name. " SET ";
			$setValue="";
			$colCount=1;
			foreach($jsonObj as $key => $value) 
			{
				$columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='order_id'){
				if($colCount===1){
					$setValue = $columnName."=:".$columnName;
				}else{
					$setValue = $setValue . "," .$columnName."=:".$columnName;
				}
				$colCount++;
				}
			}
			$setValue = rtrim($setValue,',');
			$query = $query . " " . $setValue . " WHERE order_id = :order_id"; 
			$stmt = $this->conn->prepare($query);
			foreach($jsonObj as $key => $value) 
			{
			    $columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='order_id'){
				$colValue=htmlspecialchars(strip_tags($value));
				$stmt->bindValue(":".$columnName, $colValue);
				}
			}
			$stmt->bindParam(":order_id", $this->order_id);
			$stmt->execute();

			if($stmt->rowCount()) {
				return true;
			} else {
				return false;
			}
	}
	function delete(){
		$query = "DELETE FROM " . $this->table_name . " WHERE order_id = ? ";
		$stmt = $this->conn->prepare($query);
		$this->order_id=htmlspecialchars(strip_tags($this->order_id));

		$stmt->bindParam(1, $this->order_id);

	 	$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
		 
	}

	
}
?>
