<?php
class Pets{
 
    private $conn;
    private $table_name = "pets";
	public $pageNo = 1;
	public  $no_of_records_per_page=30;
	
public $pet_id;
public $user_id;
public $pet_name;
public $breed_id;
public $pet_details;
public $is_selected;
    
    public function __construct($db){
        $this->conn = $db;
    }

	function total_record_count() {
		$query = "select count(1) as total from ". $this->table_name ."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}

	function search_count($searchKey) {
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  WHERE LOWER(t.user_id) LIKE ? OR LOWER(t.pet_name) LIKE ?  OR LOWER(t.breed_id) LIKE ?  OR LOWER(t.pet_details) LIKE ?  OR LOWER(t.is_selected) LIKE ? ";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}
	
	function search_record_count($columnArray,$orAnd){
		$where="";
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  WHERE ".$where."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
		if(strtoupper($col->columnLogic)=="LIKE"){
		$columnValue="%".strtolower($col->columnValue)."%";
		}else{
		$columnValue=strtolower($col->columnValue);
		}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		 $num = $stmt->rowCount();
		if($num>0){
			return $row['total'];
		}else{
			return 0;
		}
	}
	function read(){
		if(isset($_GET["pageNo"])){
			$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  t.* FROM ". $this->table_name ." t  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		return $stmt;
	}
	function search($searchKey){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  t.* FROM ". $this->table_name ." t  WHERE LOWER(t.user_id) LIKE ? OR LOWER(t.pet_name) LIKE ?  OR LOWER(t.breed_id) LIKE ?  OR LOWER(t.pet_details) LIKE ?  OR LOWER(t.is_selected) LIKE ?  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
		$stmt->execute();
		return $stmt;
	}
	function searchByColumn($columnArray,$orAnd){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$where="";
		
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT  t.* FROM ". $this->table_name ." t  WHERE ".$where." LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			if(strtoupper($col->columnLogic)=="LIKE"){
			$columnValue="%".strtolower($col->columnValue)."%";
			}else{
			$columnValue=strtolower($col->columnValue);
			}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		return $stmt;
	}
	
	

	function readOne(){
		$query = "SELECT  t.* FROM ". $this->table_name ." t  WHERE t.pet_id = ? LIMIT 0,1";
		$stmt = $this->conn->prepare($query);
		$stmt->bindParam(1, $this->pet_id);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		$num = $stmt->rowCount();
		if($num>0){
			
$this->pet_id = $row['pet_id'];
$this->user_id = $row['user_id'];
$this->pet_name = $row['pet_name'];
$this->breed_id = $row['breed_id'];
$this->pet_details = $row['pet_details'];
$this->is_selected = $row['is_selected'];
		}
		else{
			$this->pet_id=null;
		}
	}
	function create(){
		$query ="INSERT INTO ".$this->table_name." SET user_id=:user_id,pet_name=:pet_name,breed_id=:breed_id,pet_details=:pet_details,is_selected=:is_selected";
		$stmt = $this->conn->prepare($query);
		
$this->user_id=htmlspecialchars(strip_tags($this->user_id));
$this->pet_name=htmlspecialchars(strip_tags($this->pet_name));
$this->breed_id=htmlspecialchars(strip_tags($this->breed_id));
$this->pet_details=htmlspecialchars(strip_tags($this->pet_details));
$this->is_selected=htmlspecialchars(strip_tags($this->is_selected));
		
$stmt->bindParam(":user_id", $this->user_id);
$stmt->bindParam(":pet_name", $this->pet_name);
$stmt->bindParam(":breed_id", $this->breed_id);
$stmt->bindParam(":pet_details", $this->pet_details);
$stmt->bindParam(":is_selected", $this->is_selected);
		if($stmt->execute()){
			return  $this->conn->lastInsertId();
		}
		return 0;
	}
	function update(){
		$query ="UPDATE ".$this->table_name." SET user_id=:user_id,pet_name=:pet_name,breed_id=:breed_id,pet_details=:pet_details,is_selected=:is_selected WHERE pet_id = :pet_id";
		$stmt = $this->conn->prepare($query);
		
$this->user_id=htmlspecialchars(strip_tags($this->user_id));
$this->pet_name=htmlspecialchars(strip_tags($this->pet_name));
$this->breed_id=htmlspecialchars(strip_tags($this->breed_id));
$this->pet_details=htmlspecialchars(strip_tags($this->pet_details));
$this->is_selected=htmlspecialchars(strip_tags($this->is_selected));
$this->pet_id=htmlspecialchars(strip_tags($this->pet_id));
		
$stmt->bindParam(":user_id", $this->user_id);
$stmt->bindParam(":pet_name", $this->pet_name);
$stmt->bindParam(":breed_id", $this->breed_id);
$stmt->bindParam(":pet_details", $this->pet_details);
$stmt->bindParam(":is_selected", $this->is_selected);
$stmt->bindParam(":pet_id", $this->pet_id);
		$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
	}
	function update_patch($jsonObj) {
			$query ="UPDATE ".$this->table_name. " SET ";
			$setValue="";
			$colCount=1;
			foreach($jsonObj as $key => $value) 
			{
				$columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='pet_id'){
				if($colCount===1){
					$setValue = $columnName."=:".$columnName;
				}else{
					$setValue = $setValue . "," .$columnName."=:".$columnName;
				}
				$colCount++;
				}
			}
			$setValue = rtrim($setValue,',');
			$query = $query . " " . $setValue . " WHERE pet_id = :pet_id"; 
			$stmt = $this->conn->prepare($query);
			foreach($jsonObj as $key => $value) 
			{
			    $columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='pet_id'){
				$colValue=htmlspecialchars(strip_tags($value));
				$stmt->bindValue(":".$columnName, $colValue);
				}
			}
			$stmt->bindParam(":pet_id", $this->pet_id);
			$stmt->execute();

			if($stmt->rowCount()) {
				return true;
			} else {
				return false;
			}
	}
	function delete(){
		$query = "DELETE FROM " . $this->table_name . " WHERE pet_id = ? ";
		$stmt = $this->conn->prepare($query);
		$this->pet_id=htmlspecialchars(strip_tags($this->pet_id));

		$stmt->bindParam(1, $this->pet_id);

	 	$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
		 
	}

	
}
?>
