<?php
class Services{
 
    private $conn;
    private $table_name = "services";
	public $pageNo = 1;
	public  $no_of_records_per_page=30;
	
public $service_id;
public $sub_category_id;
public $service_name;
public $description;
public $price;
public $image;
public $isService;
public $service_duration;
public $start_service_time;
public $last_service_time;
public $current_service_time;
public $stock;
public $status;
public $date_deleted;
public $category_name;
    
    public function __construct($db){
        $this->conn = $db;
    }

	function total_record_count() {
		$query = "select count(1) as total from ". $this->table_name ."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}

	function search_count($searchKey) {
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  join sub_category yy on t.sub_category_id = yy.sub_category_id  WHERE LOWER(t.sub_category_id) LIKE ? OR LOWER(t.service_name) LIKE ?  OR LOWER(t.description) LIKE ?  OR LOWER(t.price) LIKE ?  OR LOWER(t.image) LIKE ?  OR LOWER(t.isService) LIKE ?  OR LOWER(t.service_duration) LIKE ?  OR LOWER(t.start_service_time) LIKE ?  OR LOWER(t.last_service_time) LIKE ?  OR LOWER(t.current_service_time) LIKE ?  OR LOWER(t.stock) LIKE ?  OR LOWER(t.status) LIKE ?  OR LOWER(t.date_deleted) LIKE ? ";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
$stmt->bindParam(6, $searchKey);
$stmt->bindParam(7, $searchKey);
$stmt->bindParam(8, $searchKey);
$stmt->bindParam(9, $searchKey);
$stmt->bindParam(10, $searchKey);
$stmt->bindParam(11, $searchKey);
$stmt->bindParam(12, $searchKey);
$stmt->bindParam(13, $searchKey);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}
	
	function search_record_count($columnArray,$orAnd){
		$where="";
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  join sub_category yy on t.sub_category_id = yy.sub_category_id  WHERE ".$where."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
		if(strtoupper($col->columnLogic)=="LIKE"){
		$columnValue="%".strtolower($col->columnValue)."%";
		}else{
		$columnValue=strtolower($col->columnValue);
		}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		 $num = $stmt->rowCount();
		if($num>0){
			return $row['total'];
		}else{
			return 0;
		}
	}
	function read(){
		if(isset($_GET["pageNo"])){
			$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  yy.category_name, t.* FROM ". $this->table_name ." t  join sub_category yy on t.sub_category_id = yy.sub_category_id  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		return $stmt;
	}
	function search($searchKey){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  yy.category_name, t.* FROM ". $this->table_name ." t  join sub_category yy on t.sub_category_id = yy.sub_category_id  WHERE LOWER(t.sub_category_id) LIKE ? OR LOWER(t.service_name) LIKE ?  OR LOWER(t.description) LIKE ?  OR LOWER(t.price) LIKE ?  OR LOWER(t.image) LIKE ?  OR LOWER(t.isService) LIKE ?  OR LOWER(t.service_duration) LIKE ?  OR LOWER(t.start_service_time) LIKE ?  OR LOWER(t.last_service_time) LIKE ?  OR LOWER(t.current_service_time) LIKE ?  OR LOWER(t.stock) LIKE ?  OR LOWER(t.status) LIKE ?  OR LOWER(t.date_deleted) LIKE ?  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
$stmt->bindParam(6, $searchKey);
$stmt->bindParam(7, $searchKey);
$stmt->bindParam(8, $searchKey);
$stmt->bindParam(9, $searchKey);
$stmt->bindParam(10, $searchKey);
$stmt->bindParam(11, $searchKey);
$stmt->bindParam(12, $searchKey);
$stmt->bindParam(13, $searchKey);
		$stmt->execute();
		return $stmt;
	}
	function searchByColumn($columnArray,$orAnd){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$where="";
		
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT  yy.category_name, t.* FROM ". $this->table_name ." t  join sub_category yy on t.sub_category_id = yy.sub_category_id  WHERE ".$where." LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			if(strtoupper($col->columnLogic)=="LIKE"){
			$columnValue="%".strtolower($col->columnValue)."%";
			}else{
			$columnValue=strtolower($col->columnValue);
			}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		return $stmt;
	}
	
	

	function readOne(){
		$query = "SELECT  yy.category_name, t.* FROM ". $this->table_name ." t  join sub_category yy on t.sub_category_id = yy.sub_category_id  WHERE t.service_id = ? LIMIT 0,1";
		$stmt = $this->conn->prepare($query);
		$stmt->bindParam(1, $this->service_id);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		$num = $stmt->rowCount();
		if($num>0){
			
$this->service_id = $row['service_id'];
$this->sub_category_id = $row['sub_category_id'];
$this->category_name = $row['category_name'];
$this->service_name = $row['service_name'];
$this->description = $row['description'];
$this->price = $row['price'];
$this->image = $row['image'];
$this->isService = $row['isService'];
$this->service_duration = $row['service_duration'];
$this->start_service_time = $row['start_service_time'];
$this->last_service_time = $row['last_service_time'];
$this->current_service_time = $row['current_service_time'];
$this->stock = $row['stock'];
$this->status = $row['status'];
$this->date_deleted = $row['date_deleted'];
		}
		else{
			$this->service_id=null;
		}
	}
	function create(){
		$query ="INSERT INTO ".$this->table_name." SET sub_category_id=:sub_category_id,service_name=:service_name,description=:description,price=:price,image=:image,isService=:isService,service_duration=:service_duration,start_service_time=:start_service_time,last_service_time=:last_service_time,current_service_time=:current_service_time,stock=:stock,status=:status,date_deleted=:date_deleted";
		$stmt = $this->conn->prepare($query);
		
$this->sub_category_id=htmlspecialchars(strip_tags($this->sub_category_id));
$this->service_name=htmlspecialchars(strip_tags($this->service_name));
$this->description=htmlspecialchars(strip_tags($this->description));
$this->price=htmlspecialchars(strip_tags($this->price));
$this->image=htmlspecialchars(strip_tags($this->image));
$this->isService=htmlspecialchars(strip_tags($this->isService));
$this->service_duration=htmlspecialchars(strip_tags($this->service_duration));
$this->start_service_time=htmlspecialchars(strip_tags($this->start_service_time));
$this->last_service_time=htmlspecialchars(strip_tags($this->last_service_time));
$this->current_service_time=htmlspecialchars(strip_tags($this->current_service_time));
$this->stock=htmlspecialchars(strip_tags($this->stock));
$this->status=htmlspecialchars(strip_tags($this->status));
$this->date_deleted=htmlspecialchars(strip_tags($this->date_deleted));
		
$stmt->bindParam(":sub_category_id", $this->sub_category_id);
$stmt->bindParam(":service_name", $this->service_name);
$stmt->bindParam(":description", $this->description);
$stmt->bindParam(":price", $this->price);
$stmt->bindParam(":image", $this->image);
$stmt->bindParam(":isService", $this->isService);
$stmt->bindParam(":service_duration", $this->service_duration);
$stmt->bindParam(":start_service_time", $this->start_service_time);
$stmt->bindParam(":last_service_time", $this->last_service_time);
$stmt->bindParam(":current_service_time", $this->current_service_time);
$stmt->bindParam(":stock", $this->stock);
$stmt->bindParam(":status", $this->status);
$stmt->bindParam(":date_deleted", $this->date_deleted);
		if($stmt->execute()){
			return  $this->conn->lastInsertId();
		}
		return 0;
	}
	function update(){
		$query ="UPDATE ".$this->table_name." SET sub_category_id=:sub_category_id,service_name=:service_name,description=:description,price=:price,image=:image,isService=:isService,service_duration=:service_duration,start_service_time=:start_service_time,last_service_time=:last_service_time,current_service_time=:current_service_time,stock=:stock,status=:status,date_deleted=:date_deleted WHERE service_id = :service_id";
		$stmt = $this->conn->prepare($query);
		
$this->sub_category_id=htmlspecialchars(strip_tags($this->sub_category_id));
$this->service_name=htmlspecialchars(strip_tags($this->service_name));
$this->description=htmlspecialchars(strip_tags($this->description));
$this->price=htmlspecialchars(strip_tags($this->price));
$this->image=htmlspecialchars(strip_tags($this->image));
$this->isService=htmlspecialchars(strip_tags($this->isService));
$this->service_duration=htmlspecialchars(strip_tags($this->service_duration));
$this->start_service_time=htmlspecialchars(strip_tags($this->start_service_time));
$this->last_service_time=htmlspecialchars(strip_tags($this->last_service_time));
$this->current_service_time=htmlspecialchars(strip_tags($this->current_service_time));
$this->stock=htmlspecialchars(strip_tags($this->stock));
$this->status=htmlspecialchars(strip_tags($this->status));
$this->date_deleted=htmlspecialchars(strip_tags($this->date_deleted));
$this->service_id=htmlspecialchars(strip_tags($this->service_id));
		
$stmt->bindParam(":sub_category_id", $this->sub_category_id);
$stmt->bindParam(":service_name", $this->service_name);
$stmt->bindParam(":description", $this->description);
$stmt->bindParam(":price", $this->price);
$stmt->bindParam(":image", $this->image);
$stmt->bindParam(":isService", $this->isService);
$stmt->bindParam(":service_duration", $this->service_duration);
$stmt->bindParam(":start_service_time", $this->start_service_time);
$stmt->bindParam(":last_service_time", $this->last_service_time);
$stmt->bindParam(":current_service_time", $this->current_service_time);
$stmt->bindParam(":stock", $this->stock);
$stmt->bindParam(":status", $this->status);
$stmt->bindParam(":date_deleted", $this->date_deleted);
$stmt->bindParam(":service_id", $this->service_id);
		$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
	}
	function update_patch($jsonObj) {
			$query ="UPDATE ".$this->table_name. " SET ";
			$setValue="";
			$colCount=1;
			foreach($jsonObj as $key => $value) 
			{
				$columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='service_id'){
				if($colCount===1){
					$setValue = $columnName."=:".$columnName;
				}else{
					$setValue = $setValue . "," .$columnName."=:".$columnName;
				}
				$colCount++;
				}
			}
			$setValue = rtrim($setValue,',');
			$query = $query . " " . $setValue . " WHERE service_id = :service_id"; 
			$stmt = $this->conn->prepare($query);
			foreach($jsonObj as $key => $value) 
			{
			    $columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='service_id'){
				$colValue=htmlspecialchars(strip_tags($value));
				$stmt->bindValue(":".$columnName, $colValue);
				}
			}
			$stmt->bindParam(":service_id", $this->service_id);
			$stmt->execute();

			if($stmt->rowCount()) {
				return true;
			} else {
				return false;
			}
	}
	function delete(){
		$query = "DELETE FROM " . $this->table_name . " WHERE service_id = ? ";
		$stmt = $this->conn->prepare($query);
		$this->service_id=htmlspecialchars(strip_tags($this->service_id));

		$stmt->bindParam(1, $this->service_id);

	 	$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
		 
	}

	
function readBysub_category_id(){

if (isset($_GET["pageNo"]))
{
$this->pageNo =$_GET["pageNo"]; } 
$offset = ($this->pageNo - 1) * $this->no_of_records_per_page;
$query = "SELECT  yy.category_name, t.* FROM ". $this->table_name ." t  join sub_category yy on t.sub_category_id = yy.sub_category_id  WHERE t.sub_category_id = ? LIMIT ".$offset." , ". $this->no_of_records_per_page."";

$stmt = $this->conn->prepare( $query );
$stmt->bindParam(1, $this->sub_category_id);

$stmt->execute();
return $stmt;
}

}
?>
