<?php
class Users{
 
    private $conn;
    private $table_name = "users";
	public $pageNo = 1;
	public  $no_of_records_per_page=30;
	
public $user_id;
public $first_name;
public $last_name;
public $email;
public $region_number;
public $password;
public $date_of_birth;
public $registered_date;
public $user_status;
public $user_type;
    
    public function __construct($db){
        $this->conn = $db;
    }

	function total_record_count() {
		$query = "select count(1) as total from ". $this->table_name ."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}

	function search_count($searchKey) {
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  WHERE LOWER(t.first_name) LIKE ? OR LOWER(t.last_name) LIKE ?  OR LOWER(t.email) LIKE ?  OR LOWER(t.region_number) LIKE ?  OR LOWER(t.password) LIKE ?  OR LOWER(t.date_of_birth) LIKE ?  OR LOWER(t.registered_date) LIKE ?  OR LOWER(t.user_status) LIKE ?  OR LOWER(t.user_type) LIKE ? ";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
$stmt->bindParam(6, $searchKey);
$stmt->bindParam(7, $searchKey);
$stmt->bindParam(8, $searchKey);
$stmt->bindParam(9, $searchKey);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		return $row['total'];
	}
	
	function search_record_count($columnArray,$orAnd){
		$where="";
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT count(1) as total FROM ". $this->table_name ." t  WHERE ".$where."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
		if(strtoupper($col->columnLogic)=="LIKE"){
		$columnValue="%".strtolower($col->columnValue)."%";
		}else{
		$columnValue=strtolower($col->columnValue);
		}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		 $num = $stmt->rowCount();
		if($num>0){
			return $row['total'];
		}else{
			return 0;
		}
	}
	function read(){
		if(isset($_GET["pageNo"])){
			$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  t.* FROM ". $this->table_name ." t  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$stmt->execute();
		return $stmt;
	}
	function search($searchKey){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$query = "SELECT  t.* FROM ". $this->table_name ." t  WHERE LOWER(t.first_name) LIKE ? OR LOWER(t.last_name) LIKE ?  OR LOWER(t.email) LIKE ?  OR LOWER(t.region_number) LIKE ?  OR LOWER(t.password) LIKE ?  OR LOWER(t.date_of_birth) LIKE ?  OR LOWER(t.registered_date) LIKE ?  OR LOWER(t.user_status) LIKE ?  OR LOWER(t.user_type) LIKE ?  LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		$stmt = $this->conn->prepare($query);
		$searchKey="%".strtolower($searchKey)."%";
		
$stmt->bindParam(1, $searchKey);
$stmt->bindParam(2, $searchKey);
$stmt->bindParam(3, $searchKey);
$stmt->bindParam(4, $searchKey);
$stmt->bindParam(5, $searchKey);
$stmt->bindParam(6, $searchKey);
$stmt->bindParam(7, $searchKey);
$stmt->bindParam(8, $searchKey);
$stmt->bindParam(9, $searchKey);
		$stmt->execute();
		return $stmt;
	}
	function searchByColumn($columnArray,$orAnd){
		if(isset($_GET["pageNo"])){
		$this->pageNo=$_GET["pageNo"];
		}
		$offset = ($this->pageNo-1) * $this->no_of_records_per_page; 
		$where="";
		
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			$columnLogic=$col->columnLogic;
			if($where==""){
				$where="LOWER(t.".$columnName . ") ".$columnLogic." :".$columnName;
			}else{
				$where=$where." ". $orAnd ." LOWER(t." . $columnName . ") ".$columnLogic." :".$columnName;
			}
		}
		$query = "SELECT  t.* FROM ". $this->table_name ." t  WHERE ".$where." LIMIT ".$offset." , ". $this->no_of_records_per_page."";
		
		$stmt = $this->conn->prepare($query);
		$paramCount=1;
		foreach ($columnArray as $col) {
			$columnName=htmlspecialchars(strip_tags($col->columnName));
			if(strtoupper($col->columnLogic)=="LIKE"){
			$columnValue="%".strtolower($col->columnValue)."%";
			}else{
			$columnValue=strtolower($col->columnValue);
			}
			$stmt->bindValue(":".$columnName, $columnValue);
			$paramCount++;
		}
		
		$stmt->execute();
		return $stmt;
	}
	
	

	function readOne(){
		$query = "SELECT  t.* FROM ". $this->table_name ." t  WHERE t.user_id = ? LIMIT 0,1";
		$stmt = $this->conn->prepare($query);
		$stmt->bindParam(1, $this->user_id);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		$num = $stmt->rowCount();
		if($num>0){
			
$this->user_id = $row['user_id'];
$this->first_name = $row['first_name'];
$this->last_name = $row['last_name'];
$this->email = $row['email'];
$this->region_number = $row['region_number'];
$this->password = $row['password'];
$this->date_of_birth = $row['date_of_birth'];
$this->registered_date = $row['registered_date'];
$this->user_status = $row['user_status'];
$this->user_type = $row['user_type'];
		}
		else{
			$this->user_id=null;
		}
	}
	function create(){
		$query ="INSERT INTO ".$this->table_name." SET first_name=:first_name,last_name=:last_name,email=:email,region_number=:region_number,password=:password,date_of_birth=:date_of_birth,registered_date=:registered_date,user_status=:user_status,user_type=:user_type";
		$stmt = $this->conn->prepare($query);
		
$this->first_name=htmlspecialchars(strip_tags($this->first_name));
$this->last_name=htmlspecialchars(strip_tags($this->last_name));
$this->email=htmlspecialchars(strip_tags($this->email));
$this->region_number=htmlspecialchars(strip_tags($this->region_number));
$this->password=htmlspecialchars(strip_tags($this->password));
$this->date_of_birth=htmlspecialchars(strip_tags($this->date_of_birth));
$this->registered_date=htmlspecialchars(strip_tags($this->registered_date));
$this->user_status=htmlspecialchars(strip_tags($this->user_status));
$this->user_type=htmlspecialchars(strip_tags($this->user_type));
		
$stmt->bindParam(":first_name", $this->first_name);
$stmt->bindParam(":last_name", $this->last_name);
$stmt->bindParam(":email", $this->email);
$stmt->bindParam(":region_number", $this->region_number);
$stmt->bindParam(":password", $this->password);
$stmt->bindParam(":date_of_birth", $this->date_of_birth);
$stmt->bindParam(":registered_date", $this->registered_date);
$stmt->bindParam(":user_status", $this->user_status);
$stmt->bindParam(":user_type", $this->user_type);
		if($stmt->execute()){
			return  $this->conn->lastInsertId();
		}
		return 0;
	}
	function update(){
		$query ="UPDATE ".$this->table_name." SET first_name=:first_name,last_name=:last_name,email=:email,region_number=:region_number,password=:password,date_of_birth=:date_of_birth,registered_date=:registered_date,user_status=:user_status,user_type=:user_type WHERE user_id = :user_id";
		$stmt = $this->conn->prepare($query);
		
$this->first_name=htmlspecialchars(strip_tags($this->first_name));
$this->last_name=htmlspecialchars(strip_tags($this->last_name));
$this->email=htmlspecialchars(strip_tags($this->email));
$this->region_number=htmlspecialchars(strip_tags($this->region_number));
$this->password=htmlspecialchars(strip_tags($this->password));
$this->date_of_birth=htmlspecialchars(strip_tags($this->date_of_birth));
$this->registered_date=htmlspecialchars(strip_tags($this->registered_date));
$this->user_status=htmlspecialchars(strip_tags($this->user_status));
$this->user_type=htmlspecialchars(strip_tags($this->user_type));
$this->user_id=htmlspecialchars(strip_tags($this->user_id));
		
$stmt->bindParam(":first_name", $this->first_name);
$stmt->bindParam(":last_name", $this->last_name);
$stmt->bindParam(":email", $this->email);
$stmt->bindParam(":region_number", $this->region_number);
$stmt->bindParam(":password", $this->password);
$stmt->bindParam(":date_of_birth", $this->date_of_birth);
$stmt->bindParam(":registered_date", $this->registered_date);
$stmt->bindParam(":user_status", $this->user_status);
$stmt->bindParam(":user_type", $this->user_type);
$stmt->bindParam(":user_id", $this->user_id);
		$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
	}
	function update_patch($jsonObj) {
			$query ="UPDATE ".$this->table_name. " SET ";
			$setValue="";
			$colCount=1;
			foreach($jsonObj as $key => $value) 
			{
				$columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='user_id'){
				if($colCount===1){
					$setValue = $columnName."=:".$columnName;
				}else{
					$setValue = $setValue . "," .$columnName."=:".$columnName;
				}
				$colCount++;
				}
			}
			$setValue = rtrim($setValue,',');
			$query = $query . " " . $setValue . " WHERE user_id = :user_id"; 
			$stmt = $this->conn->prepare($query);
			foreach($jsonObj as $key => $value) 
			{
			    $columnName=htmlspecialchars(strip_tags($key));
				if($columnName!='user_id'){
				$colValue=htmlspecialchars(strip_tags($value));
				$stmt->bindValue(":".$columnName, $colValue);
				}
			}
			$stmt->bindParam(":user_id", $this->user_id);
			$stmt->execute();

			if($stmt->rowCount()) {
				return true;
			} else {
				return false;
			}
	}
	function delete(){
		$query = "DELETE FROM " . $this->table_name . " WHERE user_id = ? ";
		$stmt = $this->conn->prepare($query);
		$this->user_id=htmlspecialchars(strip_tags($this->user_id));

		$stmt->bindParam(1, $this->user_id);

	 	$stmt->execute();

	 if($stmt->rowCount()) {
			return true;
		} else {
		   return false;
		}
		 
	}

	
}
?>
