<?php
include_once '../config/header.php';
include_once '../config/helper.php';
include_once '../config/database.php';
include_once '../objects/services.php';
include_once '../token/validatetoken.php';
$database = new Database();
$db = $database->getConnection();

$services = new Services($db);

$data = json_decode(file_get_contents("php://input"));
$orAnd = isset($_GET['orAnd']) ? $_GET['orAnd'] : "OR";

$services->pageNo = isset($_GET['pageno']) ? $_GET['pageno'] : 1;
$services->no_of_records_per_page = isset($_GET['pagesize']) ? $_GET['pagesize'] : 30;

$stmt = $services->searchByColumn($data,$orAnd);

$num = $stmt->rowCount();
if($num>0){
    $services_arr=array();
	$services_arr["pageno"]=$services->pageNo;
	$services_arr["pagesize"]=$services->no_of_records_per_page;
    $services_arr["total_count"]=$services->search_record_count($data,$orAnd);
    $services_arr["records"]=array();
    
    while ($row = $stmt->fetch(PDO::FETCH_ASSOC)){
        extract($row);
 
        $services_item=array(
            
"service_id" => $service_id,
"category_name" => $category_name,
"sub_category_id" => $sub_category_id,
"service_name" => $service_name,
"description" => $description,
"price" => $price,
"image" => $image,
"isService" => $isService,
"service_duration" => $service_duration,
"start_service_time" => $start_service_time,
"last_service_time" => $last_service_time,
"current_service_time" => $current_service_time,
"stock" => $stock,
"status" => $status,
"date_deleted" => $date_deleted
        );
 
        array_push($services_arr["records"], $services_item);
    }
    http_response_code(200);
	echo json_encode(array("status" => "success", "code" => 1,"message"=> "services found","document"=> $services_arr));
    
}else{
    http_response_code(404);
	echo json_encode(array("status" => "error", "code" => 0,"message"=> "No services found.","document"=> ""));
}
 


